#include "stdafx.h"
#include <cassert>
#include <fstream>
#include <iostream>
#include <iostream>
#include <boost/smart_ptr.hpp>
#include <boost/algorithm/string.hpp>
#include "tinyxml2.h"
#include "Odds2_VIP.h"
#include "FileEncrypt.h"
std::auto_ptr<Odds2_VIP> Odds2_VIP::msSingleton(nullptr);

int Odds2_VIP::GetCount()
{
	return (int)mMapData.size();
}

const Odds2_VIPData* Odds2_VIP::GetData(int VIPlvl)
{
	auto it = mMapData.find(VIPlvl);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

boost::unordered_map<int, Odds2_VIPData>& Odds2_VIP::GetMapData()
{
	return mMapData;
}

void Odds2_VIP::Reload()
{
	mMapData.clear();
	Load();
}

void Odds2_VIP::Load(const std::string& path)
{
	std::ifstream readStream(path, std::ios::binary);
	if (!readStream.is_open())
	{
		assert(false);
		return;
	}
	readStream.seekg(0, std::ios::end);
	int fileSize = readStream.tellg();
	boost::shared_array<char> buffer(new char[fileSize+1]);
	buffer.get()[fileSize] = '\0';
	readStream.seekg(0, std::ios::beg);
	readStream.read(buffer.get(), fileSize);
	readStream.close();
	FileEncrypt::decryptBuffer( buffer, fileSize );
	tinyxml2::XMLDocument xmlDoc;
	auto result = xmlDoc.Parse(buffer.get(), fileSize);
	if (result != tinyxml2::XML_SUCCESS)
	{
		assert(false);
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		assert(false);
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		Odds2_VIPData data;
		data.mVIPlvl = element->IntAttribute("VIPlvl");
		data.mExpectedProfit = element->IntAttribute("ExpectedProfit");
		data.mBuffID = element->IntAttribute("BuffID");
		data.mDragonValue = element->IntAttribute("DragonValue");
		if (mMapData.find(data.mVIPlvl) != mMapData.end())std::cout <<"data refind:" << data.mVIPlvl << std::endl;
		assert(mMapData.find(data.mVIPlvl) == mMapData.end());
		mMapData.insert(std::make_pair(data.mVIPlvl, data));
		element = element->NextSiblingElement();
	}
}

void Odds2_VIP::Load()
{
	Load("../Config/Odds2_VIP.xml");
}

Odds2_VIP* Odds2_VIP::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new Odds2_VIP());
	}
	return msSingleton.get();
}
